package com.mortals.xhx.busiz.web;

import cn.hutool.core.io.FileUtil;
import com.google.common.collect.Lists;
import com.mortals.framework.ap.GlobalSysInfo;
import com.mortals.framework.common.Rest;
import com.mortals.xhx.base.system.upload.service.UploadService;
import com.mortals.xhx.common.key.Constant;
import com.mortals.xhx.common.utils.WatermarkImgUtils;
import com.mortals.xhx.module.certificate.model.CertificateIndustryTreeSelect;
import com.mortals.xhx.module.certificate.service.CertificateIndustryService;
import com.mortals.xhx.module.child.model.ChildLicenseEntity;
import com.mortals.xhx.module.child.model.ChildLicenseQuery;
import com.mortals.xhx.module.child.service.ChildLicenseService;
import com.mortals.xhx.module.device.model.DeviceEntity;
import com.mortals.xhx.module.device.model.DeviceQuery;
import com.mortals.xhx.module.record.model.ApplyLogEntity;
import com.mortals.xhx.module.record.model.ApplyLogQuery;
import com.mortals.xhx.module.record.service.ApplyLogService;
import lombok.extern.slf4j.Slf4j;
import org.checkerframework.checker.units.qual.A;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.Date;
import java.util.List;


@RestController
@Slf4j
@RequestMapping("test")
public class TestSendMsgController {
    @Autowired
    private ApplyLogService applyLogService;
    @Autowired
    private UploadService uploadService;
    @Autowired
    private ChildLicenseService childLicenseService;
    @Autowired
    private CertificateIndustryService certificateIndustryService;


    @GetMapping("refreshWaterMark")
    public Rest<Void> updateDevice() {

        String WarterMark = GlobalSysInfo.getParamValue(Constant.Param_waterMark, "");
        ApplyLogQuery applyLogQuery = new ApplyLogQuery();
        applyLogQuery.setAnnexUrlNotList(Arrays.asList(""));
        List<ApplyLogEntity> applyLogEntities = applyLogService.find(applyLogQuery);
        for (ApplyLogEntity applyLogEntity : applyLogEntities) {
            if (!ObjectUtils.isEmpty(WarterMark)) {
                //生成水印图片
                String annexUrl = applyLogEntity.getAnnexUrl();
                String annexUrlAllPath = uploadService.getFilePath(annexUrl);
                String targetPath = "/file/fileupload/" + new Date().getTime() + "_watermark.jpg";
                String targetAllPath = uploadService.getFilePath(targetPath);
                if (FileUtil.exist(annexUrlAllPath)) {
                    WatermarkImgUtils.addWatermark(annexUrlAllPath,
                            targetAllPath,
                            WarterMark, "png");
                    applyLogEntity.setWatermarkUrl(targetPath);
                }else{
                    applyLogEntity.setWatermarkUrl("");
                }

            }

        }
        if (!ObjectUtils.isEmpty(applyLogEntities)) {
            List<List<ApplyLogEntity>> partition = Lists.partition(applyLogEntities, 100);
            for (List<ApplyLogEntity> logEntities : partition) {
                applyLogService.update(logEntities);
            }
        }

        ChildLicenseQuery childLicenseQuery = new ChildLicenseQuery();
        childLicenseQuery.setOriginalFilePathNotList(Arrays.asList(""));
        List<ChildLicenseEntity> childLicenseEntities = childLicenseService.find(childLicenseQuery);
        for (ChildLicenseEntity childLicenseEntity : childLicenseEntities) {
            if (!ObjectUtils.isEmpty(WarterMark)) {
                String originalFilePath = childLicenseEntity.getOriginalFilePath();
                String originalAllPath = uploadService.getFilePath(originalFilePath);
                String targetPath = "/file/fileupload/" + new Date().getTime() + "_watermark.jpg";
                String targetAllPath = uploadService.getFilePath(targetPath);

                if (FileUtil.exist(originalAllPath)) {
                    WatermarkImgUtils.addWatermark(originalAllPath,
                            targetAllPath,
                            WarterMark, "png");
                    childLicenseEntity.setOriginalWaterMarkPath(targetPath);
                }else{
                    childLicenseEntity.setOriginalWaterMarkPath("");
                }

            }

        }

        if (!ObjectUtils.isEmpty(childLicenseEntities)) {
            List<List<ChildLicenseEntity>> partition = Lists.partition(childLicenseEntities, 100);
            for (List<ChildLicenseEntity> licenseEntities : partition) {
                childLicenseService.update(licenseEntities);
            }
        }

        childLicenseQuery = new ChildLicenseQuery();
        childLicenseQuery.setCopyFilePathNotList(Arrays.asList(""));
        childLicenseEntities = childLicenseService.find(childLicenseQuery);
        for (ChildLicenseEntity childLicenseEntity : childLicenseEntities) {
            if (!ObjectUtils.isEmpty(WarterMark)) {
                String originalFilePath = childLicenseEntity.getOriginalFilePath();
                String originalAllPath = uploadService.getFilePath(originalFilePath);
                String targetPath = "/file/fileupload/" + new Date().getTime() + "_watermark.jpg";
                String targetAllPath = uploadService.getFilePath(targetPath);

                if (FileUtil.exist(originalAllPath)) {
                    WatermarkImgUtils.addWatermark(originalAllPath,
                            targetAllPath,
                            WarterMark, "png");
                    childLicenseEntity.setCopyWaterMarkPath(targetPath);
                }else {
                    childLicenseEntity.setCopyWaterMarkPath("");
                }

            }
        }

        if (!ObjectUtils.isEmpty(childLicenseEntities)) {
            List<List<ChildLicenseEntity>> partition = Lists.partition(childLicenseEntities, 100);
            for (List<ChildLicenseEntity> licenseEntities : partition) {
                childLicenseService.update(childLicenseEntities);
            }
        }


        return Rest.ok();
    }


    @GetMapping("subtree")
    public Rest<Object> subtree(Long parentId) {

       List<CertificateIndustryTreeSelect> allListByParentList = certificateIndustryService.getAllListByParentId(parentId, null);

        return Rest.ok(allListByParentList);
    }

    public static void main(String[] args) {


    }


}
